VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MemoryFunctions"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Public Function MemStr(Bytes As Long, Optional DecimalPlaces = 1) As String
Attribute MemStr.VB_Description = "Returns a string containg an amount of memory with appropriate units"
    If Bytes >= 1024 ^ 4 Then
        MemStr = Round(Bytes / 1024, DecimalPlaces) ^ 4 & "Tb"
    ElseIf Bytes >= 1024 ^ 3 Then
        MemStr = Round(Bytes / 1024 ^ 3, DecimalPlaces) & "Gb"
    ElseIf Bytes >= 1024 ^ 2 Then
        MemStr = Round(Bytes / 1024 ^ 2, DecimalPlaces) & "Mb"
    Else
        MemStr = Round(Bytes / 1024, DecimalPlaces) & "Kb"
    End If
End Function

Public Function CopyMem(ByVal SrcAddr As Long, ByVal DestAddr As Long, ByVal ByteCount As Long)
Attribute CopyMem.VB_Description = "Copies a chunk of memory from one address to another"
    CopyMemory DestAddr, SrcAddr, ByteCount
End Function

Public Function PeekByte(ByVal Address As Long) As Byte
    CopyMemory VarPtr(PeekByte), Address, 1
End Function

Public Function PeekBool(ByVal Address As Long) As Boolean
    CopyMemory VarPtr(PeekBool), Address, 2
End Function

Public Function PeekInt(ByVal Address As Long) As Integer
    CopyMemory VarPtr(PeekInt), Address, 2
End Function

Public Function PeekLng(ByVal Address As Long) As Long
    CopyMemory VarPtr(PeekLng), Address, 4
End Function

Public Function PeekSng(ByVal Address As Long) As Single
    CopyMemory VarPtr(PeekSng), Address, 4
End Function

Public Function PeekDbl(ByVal Address As Long) As Double
    CopyMemory VarPtr(PeekDbl), Address, 8
End Function

Public Function PeekCur(ByVal Address As Long) As Currency
    CopyMemory VarPtr(PeekCur), Address, 8
End Function

Public Function PeekDate(ByVal Address As Long) As Date
    CopyMemory VarPtr(PeekDate), Address, 8
End Function

Public Function PeekStr(ByVal Address As Long, ByVal Length As Long) As String
    PeekStr = String(Length, vbNullChar)
    CopyMemory StrPtr(PeekStr), Address, 2 * Length
End Function

Public Sub PokeByte(ByVal Address As Long, ByVal Value As Byte)
    CopyMemory Address, VarPtr(Value), 1
End Sub

Public Sub PokeBool(ByVal Address As Long, ByVal Value As Boolean)
    CopyMemory Address, VarPtr(Value), 2
End Sub

Public Sub PokeInt(ByVal Address As Long, ByVal Value As Integer)
    CopyMemory Address, VarPtr(Value), 2
End Sub

Public Sub PokeLng(ByVal Address As Long, ByVal Value As Long)
    CopyMemory Address, VarPtr(Value), 4
End Sub

Public Sub PokeSng(ByVal Address As Long, ByVal Value As Single)
    CopyMemory Address, VarPtr(Value), 4
End Sub

Public Sub PokeDbl(ByVal Address As Long, ByVal Value As Double)
    CopyMemory Address, VarPtr(Value), 8
End Sub

Public Sub PokeCur(ByVal Address As Long, ByVal Value As Currency)
    CopyMemory Address, VarPtr(Value), 8
End Sub

Public Sub PokeDate(ByVal Address As Long, ByVal Value As Date)
    CopyMemory Address, VarPtr(Value), 8
End Sub

Public Sub PokeStr(ByVal Address As Long, ByVal Value As String)
    CopyMemory Address, StrPtr(Value), LenB(Value)
End Sub

' Old QuickBasic conversion functions

Function Mki(ByVal X As Integer) As String
   Dim Temp As String * 2
   CopyVariable ByVal Temp, X, 2&
   Mki = Temp
End Function

Function Cvi(ByVal X As String) As Integer
    X = Left(X & String(2, Chr(0)), 2)
    CopyVariable Cvi, ByVal X, 2&
End Function

Function Mkl(ByVal X As Long) As String
   Dim Temp As String * 4
   CopyVariable ByVal Temp, X, 4&
   Mkl = Temp
End Function

Function Cvl(ByVal X As String) As Long
    X = Left(X & String(4, Chr(0)), 4)
    CopyVariable Cvl, ByVal X, 4&
End Function

Function Mks(ByVal X As Single) As String
   Dim Temp As String * 4
   CopyVariable ByVal Temp, X, 4&
   Mks = Temp
End Function

Function Cvs(ByVal X As String) As Single
    X = Left(X & String(4, Chr(0)), 4)
    CopyVariable Cvs, ByVal X, 4&
End Function

Function Mkd(ByVal X As Double) As String
   Dim Temp As String * 8
   CopyVariable ByVal Temp, X, 8&
   Mkd = Temp
End Function

Function Cvd(ByVal X As String) As Double
    X = Left(X & String(8, Chr(0)), 8)
    CopyVariable Cvd, ByVal X, 8&
End Function
