VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "NumericFunctions"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' returns the minimum of all parameters
'
Public Function Min(ParamArray X())
Attribute Min.VB_Description = "Returns the minimum of all parameters"
On Error Resume Next
    m = X(LBound(X))
    For i = LBound(X) + 1 To UBound(X)
        If X(i) < m Then m = X(i)
    Next
    Min = m
End Function

' returns the maximum of all parameters
'
Public Function Max(ParamArray X())
Attribute Max.VB_Description = "Returns the maximum of all parameters"
On Error Resume Next
    m = X(LBound(X))
    For i = LBound(X) + 1 To UBound(X)
        If X(i) > m Then m = X(i)
    Next
    Max = m
End Function

' returns the sum of all parameters
'
Public Function Sum(ParamArray X())
Attribute Sum.VB_Description = "Returns the sum of all parameters"
On Error Resume Next
    s = 0
    For i = LBound(X) To UBound(X)
        s = s + X(i)
    Next
    Sum = s
End Function

' returns the mean average of all parameters
'
Public Function Avg(ParamArray X())
Attribute Avg.VB_Description = "Returns the mean average of all parameters"
On Error Resume Next
    s = 0
    For i = LBound(X) To UBound(X)
        s = s + X(i)
    Next
    Avg = s / (UBound(X) - LBound(X) + 1)
End Function

' rounds a number to a given number of decimal places
'
Public Function Round(Number, Optional DecimalPlaces = 0)
Attribute Round.VB_Description = "Rounds the specified number to a specified number of decimal places"
    Round = Int(Number * 10 ^ DecimalPlaces + 0.5) / 10 ^ DecimalPlaces
End Function

' converts a number from one base to another (1 to 32)
' base 2 = binary
' base 8 = octal
' base 10 = decimal
' base 16 = hexadecimal
'
Public Function Reradix(Expression, FromBase, ToBase) As Variant
Attribute Reradix.VB_Description = "Returns a string containing the specified number in the specified base (binary-hexadecimal)"

    Dim Value As Long
    Dim InDigit(), OutDigit()
    Dim InExpr() As Byte, OutExpr() As Byte
    Dim Power As Integer, Multiple As Long, RetVal As String
    
    FromBase = CInt(FromBase)
    ToBase = CInt(ToBase)
    If FromBase < 2 Or FromBase > 32 Or ToBase < 2 Or ToBase > 32 Then Err.Raise 5
    
    InDigit() = Array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, _
                             0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, _
                             0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, _
                             0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 0, 0, 0, 0, 0, 0, _
                             0, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, _
                             25, 26, 27, 28, 29, 30, 31, 0, 0, 0, 0, 0, 0, 0, 0, 0)
    
    OutDigit() = Array(48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 65, 66, 67, 68, 69, 70, _
                               71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86)
    
    InExpr() = StrConv(StrReverse(UCase(CStr(Expression))), vbFromUnicode)

    Value = 0
    For Power = LBound(InExpr) To UBound(InExpr)
        Value = Value + FromBase ^ Power * InDigit(InExpr(Power))
    Next

    Power = 0
    While Value >= ToBase ^ Power
        Power = Power + 1
    Wend
    Power = Power - 1
    
    ReDim OutExpr(0 To Power) As Byte
    While Power >= 0
        Multiple = ToBase ^ Power
        While Value >= Multiple
            OutExpr(Power) = OutExpr(Power) + 1
            Value = Value - Multiple
        Wend
        OutExpr(Power) = OutDigit(OutExpr(Power))
        Power = Power - 1
    Wend
    
    RetVal = StrReverse(StrConv(OutExpr(), vbUnicode))
    Reradix = IIf(ToBase = 10, CLng(RetVal), RetVal)

End Function

' shorthand for converting number to binary
' (uses Radix function)
'
Public Function Bin(Number) As String
Attribute Bin.VB_Description = "Returns a binary string representing the specified number"
    Bin = Reradix(Number, 10, 2)
End Function

' converts binary string into decimal number
'
Public Function UnBin(ByVal BinaryString As String) As Long
Attribute UnBin.VB_Description = "Translates a binary string into a numeric value"
    UnBin = Reradix(BinaryString, 2, 10)
End Function
