VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WindowFunctions"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Private Declare Function Shell_NotifyIconA Lib "shell32" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Integer
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Private Type NOTIFYICONDATA
    cbSize As Long
    hwnd As Long
    uID As Long
    uFlags As Long
    uCallbackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

Private Const NIM_ADD = 0
Private Const NIM_MODIFY = 1
Private Const NIM_DELETE = 2
Private Const NIF_MESSAGE = 1
Private Const NIF_ICON = 2
Private Const NIF_TIP = 4
Private Const WM_MOUSEMOVE = &H200
Private Const WM_LBUTTONUP = &H202
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONDBLCLK = &H203
Private Const WM_RBUTTONUP = &H205
Private Const WM_RBUTTONDOWN = &H204
Private Const WM_RBUTTONDBLCLK = &H206
Private Const GWL_STYLE = (-16)
Private Const WS_MAXIMIZEBOX = &H10000
Private Const WS_MINIMIZEBOX = &H20000
Private Const ABM_REMOVE = &H1
Private Const ABM_GETSTATE = &H4
Private Const ABM_SETAUTOHIDEBAR = &H8

Public Sub AddSysTrayIcon(Form1, ByVal strToolTip As String)
Attribute AddSysTrayIcon.VB_Description = "Adds a system tray icon for the specified form"
    Shell_NotifyIconA NIM_ADD, setNOTIFYICONDATA( _
        hwnd:=Form1.hwnd, _
        ID:=vbNull, _
        Flags:=NIF_MESSAGE Or NIF_ICON Or NIF_TIP, _
        CallbackMessage:=WM_MOUSEMOVE, _
        Icon:=Form1.Icon, _
        Tip:=strToolTip)
End Sub

Public Sub DeleteSysTrayIcon(Form1)
Attribute DeleteSysTrayIcon.VB_Description = "Deletes the system tray icon for the specified form"
    Shell_NotifyIconA NIM_DELETE, setNOTIFYICONDATA( _
        hwnd:=Form1.hwnd, _
        ID:=vbNull, _
        Flags:=NIF_MESSAGE Or NIF_ICON Or NIF_TIP, _
        CallbackMessage:=WM_MOUSEMOVE, _
        Icon:=Form1.Icon, _
        Tip:="")
End Sub

Public Function AlwaysOnTop(Form1, Optional TopMost As Boolean = True)
Attribute AlwaysOnTop.VB_Description = "Sets the specified form to be always on top"
    Const HWND_TOPMOST = -&H1
    Const HWND_NOTOPMOST = -&H2
    Const SWP_NOSIZE = &H1
    Const SWP_NOMOVE = &H2
    AlwaysOnTop = SetWindowPos(Form1.hwnd, IIf(TopMost, HWND_TOPMOST, HWND_NOTOPMOST), 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
End Function

Private Function setNOTIFYICONDATA(hwnd As Long, ID As Long, Flags As Long, CallbackMessage As Long, Icon As Long, Tip As String) As NOTIFYICONDATA

    Dim nidTemp As NOTIFYICONDATA
   
    nidTemp.cbSize = Len(nidTemp)
    nidTemp.hwnd = hwnd
    nidTemp.uID = ID
    nidTemp.uFlags = Flags
    nidTemp.uCallbackMessage = CallbackMessage
    nidTemp.hIcon = Icon
    nidTemp.szTip = Tip & Chr(0)

    setNOTIFYICONDATA = nidTemp
    
End Function



